SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")

local frame = CreateFrame("Frame", "SortGroupPanel", UIParent);
-- Main Frame

GroupDown = false;
GroupUp = false;
GroupAutoActivate = false;
raidProfile = nil;
-- local CRFSort_Group;
-- Chosen Options

loginScreen = false;
-- true when "PLAYER_ENTERING_WORLD" fired

inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired

local cBDown = CreateFrame("CheckButton", "CheckButtonDown_Text", frame, "UICheckButtonTemplate");
local cBUp = CreateFrame("CheckButton", "CheckButtonUp_Text", frame, "UICheckButtonTemplate");
local cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", frame, "UICheckButtonTemplate");
-- Combo-box Options

local btnReload = CreateFrame("Button", "Button_Text", frame, "UIPanelButtonTemplate");
-- Reload Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", frame, "UIDropDownMenuTemplate");
ddmItems = {};
-- DropDownMenu

local function createFrame()	
	frame.name = "SortGroup";
	font = frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	font:SetFont("Fonts\\FRIZQT__.TTF", 18);
	font:SetTextColor(1, 0.8, 0);
    font:SetPoint("TOPLEFT", 12, -18);
    font:SetText("SortGroup");
	InterfaceOptions_AddCategory(frame);
end

local function frameEvent()
	frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				SortGroupInformation.Down = GroupDown;
				SortGroupInformation.Up = GroupUp;
				SortGroupInformation.Profile = raidProfile;
				SortGroupInformation.AutoActivate = GroupAutoActivate;
				frame:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				inCombat = false;
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				--CompactUnitFrameProfiles.cancel = function() end;
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
				end
				
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
				end
				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = true;
				end
				
				GroupDown = SortGroupInformation.Down;
				GroupUp = SortGroupInformation.Up;
				GroupAutoActivate = SortGroupInformation.AutoActivate;
				if ( ReadAllRaidProfiles(SortGroupInformation.Profile) == false ) then
					cache = L["RaidProfil_dont_exists"]:gsub("'replacement'", SortGroupInformation.Profile);
					SortGroupInformation.Profile = GetRaidProfileName(1);
					print(cache:gsub("'replacement2'", SortGroupInformation.Profile));
				end
				raidProfile = SortGroupInformation.Profile;
				UIDropDownMenu_SetText(ddmProfiles, raidProfile)
				
				ChangesComboBoxes();
				if ( GroupDown == true ) then
					GroupUp = false;
					SortBy('Down', raidProfile);
				end				
				if ( GroupUp == true ) then
					GroupDown = false;
					SortBy('Up', raidProfile);
				end			
				frame:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and inCombat == false) then	
				loginScreen = true;
				if ( ReadAllRaidProfiles(raidProfile) == false ) then
					cache = L["RaidProfil_dont_exists"]:gsub("'replacement'", raidProfile);
					raidProfile = GetRaidProfileName(1);
					print(cache:gsub("'replacement2'", raidProfile));
				end
				if ( GroupDown == true ) then
					SortBy('Down', raidProfile);
				end			
				if ( GroupUp == true ) then	
					SortBy('Up', raidProfile);
				end
			end
		end);
end

local function createCheckbox()		
	cBDown:SetPoint("TOPLEFT", 10, -65);
	cBUp:SetPoint("TOPLEFT",10, -100);
	cbAutoActivate:SetPoint("TOPLEFT",220,-65);
	
	getglobal(cBDown:GetName() .. 'Text'):SetText(L["cBDown_Option_Text"]);
	getglobal(cBUp:GetName() .. 'Text'):SetText(L["cBUp_Option_Text"]);
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
end

local function checkBoxEvent()
	cBDown:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = false;
				InGroupText();
				if ( cBDown:GetChecked() == true ) then
					GroupDown = true;
					GroupUp = false;
					cBUp:SetChecked(false);
					SortBy('Down', raidProfile);
				elseif ( cBDown:GetChecked() == false ) then	
					GroupDown = false;
					SortBy(nil,raidProfile);
				end
			else
				ChangesComboBoxes();
				print(L["in_combat_options"]);
			end
		end);		
	cBDown:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBDown_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBDown:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Down
		
	cBUp:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = false;
				InGroupText();
				if ( cBUp:GetChecked() == true ) then
					GroupDown = false;
					GroupUp = true;
					cBDown:SetChecked(false);
					SortBy('Up', raidProfile);
				elseif ( cBUp:GetChecked() == false ) then	
					GroupUp = false;
					SortBy(nil,raidProfile);
				end
			else
				ChangesComboBoxes();
				print(L["in_combat_options"]);
			end
		end);
	cBUp:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBUp_ToolTip_text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBUp:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
		
	cbAutoActivate:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = false;
				InGroupText();
				if ( cbAutoActivate:GetChecked() == true ) then
					GroupAutoActivate = true;
				if( cBDown:GetChecked() == true ) then
					SortBy('Down', raidProfile);
				elseif ( cBUp:GetChecked() == true ) then
					SortBy('Up', raidProfile);
				end
				elseif ( cbAutoActivate:GetChecked() == false ) then
					GroupAutoActivate = false;
				end
			else
				ChangesComboBoxes();
				print(L["in_combat_options"]);
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end

local function createButton()
	btnReload:SetSize(84, 24);
	btnReload:SetText(L["btn_Option_text"]);
	btnReload:SetPoint("TOPLEFT", 10, -150);
end

local function buttonEvent()
	btnReload:SetScript("OnClick", 
		function()
			ReloadUI();
		end);
end

local function createDropDownMenu()
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", 210, -110);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( inCombat == false and level == 1 ) then
			wipe(self.info);
			ReadAllRaidProfiles();
			for i, value in pairs(ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = value;
					raidProfile = value;
					loginScreen = false;
					InGroupText();
					if( GroupDown == true ) then
						SortBy('Down',raidProfile);
					elseif ( GroupUp == true ) then
						SortBy('Up',raidProfile);
					end
					UIDropDownMenu_SetText(ddmProfiles, raidProfile);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
			end
		else
			print(L["in_combat_options"]);
		end
	end
end


function SortDown()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
	--hooksecurefunc(CompactRaidFrameContainer, "flowSortFunc", hook_flowSortFunc)
end
	
function SortUp()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
	--hooksecurefunc(CompactRaidFrameContainer, "flowSortFunc", hook_flowSortFunc)
end

--function hook_flowSortFunc(self)
	--print("testus");
	--CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
	--self.flowSortFunc = CRFSort_Group;
	--CompactRaidFrameContainer_TryUpdate(self);
--end
-- Secure call of CompactRaidFrameContainer.flowSortFunc. Doesn't work yet


function SortBy(SortOption, RaidProfileName)	
	if ( RaidProfileName ~= nil and GetNumGroupMembers() < 5 and HasLoadedCUFProfiles() == true) then
		if ( GetActiveRaidProfile() ~= RaidProfileName and GroupAutoActivate == true) then
			CompactUnitFrameProfiles_ActivateRaidProfile(RaidProfileName);
		end
		if ( GetActiveRaidProfile() == RaidProfileName ) then
			if ( SortOption == 'Down') then
				if ( loginScreen == false ) then
					print((L["sort_down"]:gsub("'replacement'", RaidProfileName)));
				else
					loginScreen = false;
				end
				CheckRaidProfileOptions();
				SortDown();
			elseif ( SortOption == 'Up') then
				if ( loginScreen == false ) then
					print((L["sort_up"]:gsub("'replacement'", RaidProfileName)));
				else
					loginScreen = false;
				end
				CheckRaidProfileOptions();
				SortUp();
			end
		else
			print (L["sort_no"]);
		end		
	end
end

function InGroupText()
	if ( GetNumGroupMembers() > 1 ) then
		print(L["Currently_in_a_group"]);
		return true;
	end
	return false;
end

function CheckRaidProfileOptions()
	if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
		CompactUnitFrameProfilesRaidStylePartyFrames:Click(true);
	end
	if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
		CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);		
	end
end

function ReadAllRaidProfiles(raidProfile)
	raidprofilexists = false;
	for i=1, GetNumRaidProfiles(), 1 do
		ddmItems[i] = GetRaidProfileName(i);
		if ( ddmItems[i] == raidProfile ) then
			raidprofilexists = true;
		end
	end
	if ( raidprofilexists == true ) then
		return true;
	end
	return false;
end

function ChangesComboBoxes()
	if ( GroupAutoActivate == true ) then
		cbAutoActivate:SetChecked(true);
	else
		cbAutoActivate:SetChecked(false);
	end
	if ( GroupDown == true ) then
		cBDown:SetChecked(true);
		cBUp:SetChecked(false);
	elseif ( GroupUp == true ) then
		cBDown:SetChecked(false);
		cBUp:SetChecked(true);
	else
		cBDown:SetChecked(false);
		cBUp:SetChecked(false);
	end
end

function StartAddon()
	--CompactUnitFrameProfiles:UnregisterAllEvents()
	createFrame();
	createCheckbox();
	checkBoxEvent();
	createButton();
	buttonEvent();
	frameEvent();
	createDropDownMenu();	
end
StartAddon();